{*******************************************************}
{                                                       }
{              Extinifiles  Component                   }
{                                                       }
{       Copyright (c) 1998,2000 Qingyuan Studio         }
{                                                       }
{*******************************************************}

unit Extinifiles;


{$R-}

interface

uses Windows,Classes,Dialogs;

type
  TExtIniFile = class(TObject)  //extini Ǳ׼INIļչ
  private
    FFileName: string;
    FList:TStringList;
    Str_Temp:String;
  public
    constructor Create(const FileName: string);
    function ReadString(const Section:String; Ident:String; Default: string): string;//ַ
    function ReadInteger(const Section:String; Ident:String;Default: Longint): Longint;//ֵ
    function ReadBoolean(const Section:String; Ident:String;Default: Boolean): Boolean;//ݲ
    procedure ReadSections(Strings: TStrings);//ȫε
    procedure ReadIdents(const Section:String;Strings: TStrings);//ָڵļ
    property FileName: string read FFileName;
    procedure WriteString(const Section:String; Ident:String;Value: String);//дַ
    procedure WriteInteger(const Section:String; Ident:String;Value: Integer);//дֵ
    procedure WriteBoolean(const Section:String; Ident:String;Value: Boolean);//д
  end;

implementation

uses SysUtils, Consts;

constructor TExtIniFile.Create(const FileName: string);
begin
  FFileName := FileName;
  FList:=TStringList.Create;

  //ļ
  if FileExists(Filename) then begin
     FList.LoadFromFile(FileName);
     if FList.Strings[FList.Count-1]<>'' then FList.Add ('');
  end;
  //ļ
  if FileExists(Filename)=false then begin
     FList.Add(';Qingyuan Extinifile');
     FList.Add(';http://qingyuan.csw.cnshare.net/');
     FList.Add('');
  end;
end;

function TExtIniFile.ReadString(const Section:String; Ident:String; Default: string): string;//ַ
var
   ExtIni_I,ExtIni_Start,ExtIni_End,BufSize:Integer;
   Section_Str,Ident_Str:String;
   //TempList:TStringList;
   Buffer,Pchar_Temp:Pchar;
   IdentLen:Integer;
   FindEndOK:Boolean;
begin
  //ļ
  if FileExists(FFileName) then begin
     FindEndOK:=False;
     ExtIni_Start:=-1;
     ExtIni_End:=-1;
     IdentLen:= Length(Ident);
     //ȫģSection                                                                                                                                                                                                                                              For ExtIni_I:=0 to LoadStringList.Count -1 do begin
     For ExtIni_I:=0 to FList.Count -1 do begin
         if UpperCase(FList.Strings[ExtIni_I])= '['+UpperCase(Section)+']'  then  begin
            if ExtIni_Start=-1 then begin
               ExtIni_Start:=ExtIni_I;
            end;
         end;
     end;

     //Section ɹ
     if ExtIni_Start>-1 then begin
        For ExtIni_I:=ExtIni_Start+1 to FList.Count -1 do begin
          BufSize:= Length(FList.Strings[ExtIni_I]);
          GetMem(Buffer, BufSize+2);
          Buffer^ :=chr(0);
          //ȡһַ
          strLcat(Buffer,PChar(FList.Strings[ExtIni_I]),1);
          //һַΪ'['
          If Buffer='[' then FindEndOK:=True;
          //Ϊֵ
          if FList.Strings[ExtIni_I]='' then FindEndOK:=True;
          //ǸöεĽ
          if FindEndOK=True then begin
             if ExtIni_End=-1 then begin
                ExtIni_End:= ExtIni_I;
             end;
          end;
          //ͷڴ
          FreeMem(Buffer);
        end;

        //
        For ExtIni_I:=0 to ExtIni_End -1  do begin
            BufSize:= Length(FList.Strings[ExtIni_I]);
            GetMem(Buffer, BufSize+2);
            Buffer^ :=chr(0);
            strLcat(Buffer,PChar(FList.Strings[ExtIni_I]),IdentLen+1);
            //ɹ
            if UpperCase(String(Buffer))=UpperCase(Ident+'=') then begin
               //ַ
               BufSize:= Length(FList.Strings[ExtIni_I]);
               GetMem(Pchar_Temp, BufSize);
               Pchar_Temp^ :=chr(0);
               StrCat(Pchar_Temp, PChar(FList.Strings[ExtIni_I])+Length(Ident)+1);
               Str_Temp:=String(Pchar_Temp);
               //ͷڴ
               FreeMem(Pchar_Temp);
            end;
            FreeMem(Buffer);
        end;
     end;
  end;
SetString(Result,pchar(Str_Temp),Length(Str_Temp) );
if trim(Str_Temp)= '' then Result:=Default;
end;

function TExtIniFile.ReadInteger(const Section:String;Ident: string; Default: Longint): Longint;
var
  IntStr: string;
begin
     try
         IntStr := ReadString(Section, Ident, '');
         if (Length(IntStr) > 2) and (IntStr[1] = '0') and
            ((IntStr[2] = 'X') or (IntStr[2] = 'x')) then
            IntStr := '$' + Copy(IntStr, 3, Maxint);
            Result := StrToIntDef(IntStr, Default);
     finally
            Result := StrToIntDef(IntStr, Default);
     end;
end;

function TExtIniFile.ReadBoolean(const Section:String;Ident: string; Default: Boolean): Boolean;
begin
     if Trim(ReadString(Section, Ident, 'A'))='1' then Result:=true else Result:=false;
     if (Str_Temp<>'0') and (Str_Temp<>'1') then Result:=Default;
end;

procedure TExtIniFile.ReadSections(Strings: TStrings);//ȫε
var
   ExtIni_I,BufSize:Integer;
   Buffer,Pchar_Temp,Pchar_Temp2,Pchar_Temp3:Pchar;
   FindEndOK:Boolean;
begin
     //ļ
     if FileExists(FFileName) then begin
        For ExtIni_I:=0 to FList.Count -1 do begin
            BufSize:= Length(FList.Strings[ExtIni_I])+2;
            GetMem(Buffer,BufSize );
            Buffer^ :=chr(0);
            //ȡһַ
            strLcat(Buffer,PChar(FList.Strings[ExtIni_I]),1);
            //һַΪ'['
            If Buffer='[' then begin
               //']'
               GetMem(Pchar_Temp,BufSize);
               Pchar_Temp^ :=chr(0);
               StrCat(Pchar_Temp, PChar(FList.Strings[ExtIni_I])+ Length(FList.Strings[ExtIni_I])- 1);

               if Pchar_Temp=']' then begin
                  GetMem(Pchar_Temp2, BufSize);
                  Pchar_Temp2^ :=chr(0);
                  StrCat(Pchar_Temp2, PChar(FList.Strings[ExtIni_I])+1);


                  GetMem(Pchar_Temp3, BufSize);
                  Pchar_Temp3^ :=chr(0);
                  strLcat(Pchar_Temp3,Pchar_Temp2,Length(Pchar_Temp2)-1);
                  //бмַ
                  Strings.Add(Pchar_Temp3);

                  FreeMem(Pchar_Temp2);
                  FreeMem(Pchar_Temp3);

               end;
               FreeMem(Pchar_Temp);
            end;
            FreeMem(Buffer);
        end;
     end;
end;

procedure TExtIniFile.ReadIdents(const Section:String;Strings: TStrings);//ָڵļ
var
   ExtIni_I,ExtIni_Start,ExtIni_End,BufSize:Integer;
   Section_Str,Ident_Str:String;
   TempList:TStringList;
   Buffer,Pchar_Temp:Pchar;
   IdentLen:Integer;
   FindEndOK:Boolean;
begin
  //ļ
  if FileExists(FFileName) then begin
     FindEndOK:=False;
     ExtIni_Start:=-1;
     ExtIni_End:=-1;
     //ȫģSection                                                                                                                                                                                                                                              For ExtIni_I:=0 to LoadStringList.Count -1 do begin
     For ExtIni_I:=0 to FList.Count -1 do begin
         if UpperCase(FList.Strings[ExtIni_I])= '['+UpperCase(Section)+']'  then  begin
            if ExtIni_Start=-1 then begin
               ExtIni_Start:=ExtIni_I;
            end;
         end;
     end;

     //Section ɹ
     if ExtIni_Start>-1 then begin
        For ExtIni_I:=ExtIni_Start+1 to FList.Count -1 do begin
            BufSize:=Length(FList.Strings[ExtIni_I]);
            GetMem(Buffer, BufSize+2);
            Buffer^ :=chr(0);
            //ȡһַ
            strLcat(Buffer,PChar(FList.Strings[ExtIni_I]),1);
            //һַΪ'['
            If Buffer='[' then FindEndOK:=True;
            //Ϊֵ
            if FList.Strings[ExtIni_I]='' then FindEndOK:=True;
            //ǸöεĽ
            if FindEndOK=True then begin
               if ExtIni_End=-1 then begin
               ExtIni_End:= ExtIni_I;
               end;
            end;
            //ͷڴ
            FreeMem(Buffer);
        end;
     end;

     For ExtIni_I:=ExtIni_Start+1 to ExtIni_End-1 do begin
         //'='
        IdentLen:= pos('=',FList.Strings[ExtIni_I]);
        if IdentLen<>0 then begin
           BufSize:=Length(FList.Strings[ExtIni_I]);
           GetMem(Buffer, BufSize+2);
           Buffer^ :=chr(0);

           //ȡַ
           strLcat(Buffer,PChar(FList.Strings[ExtIni_I]),IdentLen-1);
           Strings.Add(Buffer);
           freemem(Buffer);
        end;
     end;
  end;
end;

procedure TExtIniFile.WriteString(const Section:String; Ident:String;Value: String);
var
   ExtIni_I,ExtIni_Start,ExtIni_End,BufSize:Integer;
   Buffer:Pchar;
   IdentLen:Integer;
   FindEndOK,FindOK:Boolean;
begin
     FindEndOK:=False;
     FindOK:=False;
     ExtIni_Start:=-1;
     ExtIni_End:=-1;
     IdentLen:=Length(Ident);
     //б
     if FList.Count >0 then begin
        //ȫģSection                                                                                                                                                                                                                                              For ExtIni_I:=0 to LoadStringList.Count -1 do begin
        For ExtIni_I:=0 to FList.Count -1 do begin
            if UpperCase(FList.Strings[ExtIni_I])= '['+UpperCase(Section)+']'  then  begin
               if ExtIni_Start=-1 then begin
                  ExtIni_Start:=ExtIni_I;
               end;
            end;
        end;
        //Section ʧ
        if ExtIni_Start=-1 then begin
           FList.Add ('['+Section+']');
           ExtIni_Start:= FList.Count-1 ;
        end ;
        //Section ɹ
        if ExtIni_Start>-1 then begin
           For ExtIni_I:=ExtIni_Start+1 to FList.Count -1 do begin
               BufSize:=Length(FList.Strings[ExtIni_I]);
               GetMem(Buffer, BufSize+2);
               Buffer^ :=chr(0);
               //ȡһַ
               strLcat(Buffer,PChar(FList.Strings[ExtIni_I]),1);
               //һַΪ'['
               If Buffer='[' then FindEndOK:=True;
               //Ϊֵ
               if FList.Strings[ExtIni_I]='' then FindEndOK:=True;
               //ǸöεĽ
               if FindEndOK=True then begin
                  if ExtIni_End=-1 then begin
                  ExtIni_End:= ExtIni_I;
                  end;
               end;
               //ͷڴ
               FreeMem(Buffer);
           end;
        end;
        //ûҵεĽ
        if ExtIni_End =-1 then FList.Add (Ident+'='+ Value);
        //ҵεĽ
        if ExtIni_End<>-1 then begin
           //
           for ExtIni_I:=ExtIni_Start+1 to ExtIni_End  do begin
               BufSize:=Length(FList.Strings[ExtIni_I]);
               GetMem(Buffer, BufSize+2);
               Buffer^ :=chr(0);
               strLcat(Buffer,PChar(FList.Strings[ExtIni_I]),IdentLen+1);
               //ɹ
               if UpperCase(String(Buffer))=UpperCase(Ident+'=') then begin
                  FList.Strings[ExtIni_I]:=Ident+'='+ Value;
                  FindOK:=True;
               end;
               FreeMem(Buffer, BufSize);
           end;
           //ʧ
           if FindOK=false then FList.Insert(ExtIni_End ,Ident+'='+ Value);
        end;
     end;
     if FList.Count =0 then begin
        FList.Add ('['+Section+']');
        FList.Add ( Ident+'='+ Value);
     end;
        FList.SaveToFile(FFileName);
end;

procedure TExtIniFile.WriteInteger(const Section:String; Ident:String;Value: Integer);
begin
WriteString(Section, Ident,inttostr(Value));
end;

procedure TExtIniFile.WriteBoolean(const Section:String; Ident:String;Value: Boolean);
begin
if Value=true then WriteString(Section, Ident,'1') else WriteString(Section, Ident,'0');
end;
end.
